--[[

|=================================================|
|-------------------------------------------------|
|-------------Script do Unia Polonez--------------|
|-----------------by maciusboss1------------------|
|----------------Skrypt BY Burner-----------------|
|----------------Data: 10.08.2013-----------------|
|-------------------M & B Team--------------------|
|--------------------No Edit!!!-------------------|
|-------------------------------------------------|
|=================================================|

]]--

UniaPolonez = {};

function UniaPolonez.prerequisitesPresent(specializations)
	return true;
end;

function UniaPolonez:load(xmlFile)
	self.objectInRange = UniaPolonez.objectInRange;
	self.setTramlinesOn = SpecializationUtil.callSpecializationsFunction("setTramlinesOn");
	
	self.leftMarkerSpeedRotatingParts = {};
	local i=0;
	while true do
		local baseName = string.format("vehicle.leftMarkerSpeedRotatingParts.leftMarkerSpeedRotatingPart(%d)", i);
		local index = getXMLString(xmlFile, baseName.. "#index");
		if index == nil then
			break;
		end;
		local node = Utils.indexToObject(self.components, index);
		if node ~= nil then
			local entry = {};
			entry.node = node;
			entry.rotationSpeedScale = getXMLFloat(xmlFile, baseName.."#rotationSpeedScale");
			if entry.rotationSpeedScale == nil then
				entry.rotationSpeedScale = 1.0/Utils.getNoNil(getXMLFloat(xmlFile, baseName.."#radius"), 1);
			end;
			entry.foldMinLimit = Utils.getNoNil(getXMLFloat(xmlFile, baseName .. "#foldMinLimit"), 0);
			entry.foldMaxLimit = Utils.getNoNil(getXMLFloat(xmlFile, baseName .. "#foldMaxLimit"), 1);
			table.insert(self.leftMarkerSpeedRotatingParts, entry);
		end;
		i = i+1;
	end;
	
	self.rightMarkerSpeedRotatingParts = {};
	local i=0;
	while true do
		local baseName = string.format("vehicle.rightMarkerSpeedRotatingParts.rightMarkerSpeedRotatingPart(%d)", i);
		local index = getXMLString(xmlFile, baseName.. "#index");
		if index == nil then
			break;
		end;
		local node = Utils.indexToObject(self.components, index);
		if node ~= nil then
			local entry = {};
			entry.node = node;
			entry.rotationSpeedScale = getXMLFloat(xmlFile, baseName.."#rotationSpeedScale");
			if entry.rotationSpeedScale == nil then
				entry.rotationSpeedScale = 1.0/Utils.getNoNil(getXMLFloat(xmlFile, baseName.."#radius"), 1);
			end;
			entry.foldMinLimit = Utils.getNoNil(getXMLFloat(xmlFile, baseName .. "#foldMinLimit"), 0);
			entry.foldMaxLimit = Utils.getNoNil(getXMLFloat(xmlFile, baseName .. "#foldMaxLimit"), 1);
			table.insert(self.rightMarkerSpeedRotatingParts, entry);
		end;
		i = i+1;
	end;
	
	self.leftMarkerParticleSystems = {};
	local psName = "vehicle.leftMarkerParticleSystem";
	Utils.loadParticleSystem(xmlFile, self.leftMarkerParticleSystems, psName, self.components, false, nil, self.baseDirectory);
	self.rightMarkerParticleSystems = {};
	local psName = "vehicle.rightMarkerParticleSystem";
	Utils.loadParticleSystem(xmlFile, self.rightMarkerParticleSystems, psName, self.components, false, nil, self.baseDirectory);
	
	self.numTramlinesAreas = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.tramlinesAreas#count"), 0);
    self.tramlinesAreas = {}
    for i=1, self.numTramlinesAreas do
        self.tramlinesAreas[i] = {};
        local areanamei = string.format("vehicle.tramlinesAreas.tramlinesArea%d", i);
        self.tramlinesAreas[i].start = Utils.indexToObject(self.components, getXMLString(xmlFile, areanamei .. "#startIndex"));
        self.tramlinesAreas[i].width = Utils.indexToObject(self.components, getXMLString(xmlFile, areanamei .. "#widthIndex"));
        self.tramlinesAreas[i].height = Utils.indexToObject(self.components, getXMLString(xmlFile, areanamei .. "#heightIndex"));
    end;
	
	self.tramlines = false;
	self.fillPlanesBackup = self.fillPlanes;
	self.fillPlanes = nil;
	self.lastSeed = self.currentSeed;
end;

function UniaPolonez:delete()
	Utils.deleteParticleSystem(self.leftMarkerParticleSystems);
	Utils.deleteParticleSystem(self.rightMarkerParticleSystems);
end;

function UniaPolonez:readStream(streamId, connection)
	self:setTramlinesOn(streamReadBool(streamId), true);
end;

function UniaPolonez:writeStream(streamId, connection)
	streamWriteBool(streamId, self.tramlines);
end;

function UniaPolonez:mouseEvent(posX, posY, isDown, isUp, button)
end;

function UniaPolonez:keyEvent(unicode, sym, modifier, isDown)
end;

function UniaPolonez:update(dt)
	if self:objectInRange(self.animationParts[1].rootNode) then
		if InputBinding.hasEvent(InputBinding.UniaPolonez_KLAPA) then
			if self.animationParts[1].clipEndTime then
				self:setAnimationTime(1, self.animationParts[1].offSet);
			elseif self.animationParts[1].clipStartTime then
				self:setAnimationTime(1, self.animationParts[1].animDuration);
			end;
		end;
		if self.animationParts[1].clipEndTime then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UniaPolonez_KLAPA_Close")), InputBinding.UniaPolonez_KLAPA);
		else
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UniaPolonez_KLAPA")), InputBinding.UniaPolonez_KLAPA);
		end;
	end;

	if self:objectInRange(self.animationParts[2].rootNode) then
		if InputBinding.hasEvent(InputBinding.UniaPolonez_GRABIE) then
			if self.animationParts[2].clipEndTime then
				self:setAnimationTime(2, self.animationParts[2].offSet);
			elseif self.animationParts[2].clipStartTime then
				self:setAnimationTime(2, self.animationParts[2].animDuration);
			end;                                                                                                                     
		end;
		if self.animationParts[2].clipEndTime then
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UniaPolonez_GRABIE_Down")), InputBinding.UniaPolonez_GRABIE);
		else
			g_currentMission:addHelpButtonText(string.format(g_i18n:getText("UniaPolonez_GRABIE")), InputBinding.UniaPolonez_GRABIE);
		end;
	end;
	
	if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.UniaPolonez_TRAMLINES) then
			self:setTramlinesOn(not self.tramlines);
		end;
	end;
	
	-- display plane for selected fruit type
	if self.lastSeed ~= self.currentSeed and self.currentSeedPlane ~= nil then
		for _, node in ipairs(self.currentSeedPlane.nodes) do
			setVisibility(node.node, false);
		end;
	end;
	
	local fillTypeName = Fillable.fillTypeIntToName[self.seeds[self.currentSeed]];
	if self.fillPlanesBackup[fillTypeName] ~= nil then
		self.currentSeedPlane = self.fillPlanesBackup[fillTypeName];
	else
		self.currentSeedPlane = self.defaultFillPlane;
	end;

	local t = 0;
	if self.currentSeedPlane ~= nil then
		t = self.fillLevel/self.capacity;
		for _, node in ipairs(self.currentSeedPlane.nodes) do
			local x,y,z, rx,ry,rz, sx,sy,sz = node.animCurve:get(t);
			setTranslation(node.node, x, y, z);
			setRotation(node.node, rx, ry, rz);
			setScale(node.node, sx, sy, sz);
			setVisibility(node.node, self.fillLevel > 0 or node.alwaysVisible);
		end;
	end;

	self.lastSeed = self.currentSeed;
end;

function UniaPolonez:objectInRange(object)
	if g_currentMission.player ~= nil and object ~= nil then
		local nearestDistance = 3;
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
		local px, py, pz = getWorldTranslation(object);
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
		if distance < nearestDistance then
			return true;
		else
			return false;
		end;
	else
		return false;
	end;
end;

function UniaPolonez:updateTick(dt)
	if self.ridgeMarkerState == 1 and self:isLowered(false) then
		if self:getAnimationTime(self.ridgeMarkerAnimationLeftName) > 0.99 then
			for k,v in pairs(self.leftMarkerSpeedRotatingParts) do
				rotate(v.node, v.rotationSpeedScale * self.lastSpeedReal * self.movingDirection * dt, 0, 0);
			end;
			if self.lastSpeed*3600 > 3 then
				Utils.setEmittingState(self.leftMarkerParticleSystems, true);
			else
				Utils.setEmittingState(self.leftMarkerParticleSystems, false);
			end;
		else
			Utils.setEmittingState(self.leftMarkerParticleSystems, false);
		end;
		Utils.setEmittingState(self.rightMarkerParticleSystems, false);
	elseif self.ridgeMarkerState == 2 and self:isLowered(false) then
		if self:getAnimationTime(self.ridgeMarkerAnimationRightName) > 0.99 then
			for k,v in pairs(self.rightMarkerSpeedRotatingParts) do
				rotate(v.node, v.rotationSpeedScale * self.lastSpeedReal * self.movingDirection * dt, 0, 0);
			end;
			if self.lastSpeed*3600 > 3 then
				Utils.setEmittingState(self.rightMarkerParticleSystems, true);
			else
				Utils.setEmittingState(self.rightMarkerParticleSystems, false);
			end;
		else
			Utils.setEmittingState(self.rightMarkerParticleSystems, false);
		end;
		Utils.setEmittingState(self.leftMarkerParticleSystems, false);
	else
		Utils.setEmittingState(self.rightMarkerParticleSystems, false);
		Utils.setEmittingState(self.leftMarkerParticleSystems, false);
	end;
		
	-- tramlines
	local hasGroundContact = self.sowingMachineHasGroundContact;
	local doGroundManipulation = (self.movingDirection > 0 and hasGroundContact and (not self.needsActivation or self.isTurnedOn));
	if doGroundManipulation then
		if self.tramlines then
			for k, tramlinesArea in pairs(self.tramlinesAreas) do
				local x,y,z = getWorldTranslation(tramlinesArea.start);
				local x1,y1,z1 = getWorldTranslation(tramlinesArea.width);
				local x2,y2,z2 = getWorldTranslation(tramlinesArea.height);
				Utils.updateCultivatorArea(x, z, x1, z1, x2, z2, false);
			end;
		end;
	end;
end;

function UniaPolonez:setTramlinesOn(tramlinesOn, noEventSend)
	SetTramlinesOnEvent.sendEvent(self, tramlinesOn, noEventSend)
	self.tramlines = tramlinesOn;
end;

function UniaPolonez:draw()
	if self.isClient then
		if self.tramlines then
			g_currentMission:addHelpButtonText(g_i18n:getText("UniaPolonez_TRAMLINES_off"), InputBinding.UniaPolonez_TRAMLINES);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("UniaPolonez_TRAMLINES"), InputBinding.UniaPolonez_TRAMLINES);
		end;
	end
end;

function UniaPolonez:onAttach(attacherVehicle)
end;

function UniaPolonez:onDetach()
end;

function UniaPolonez:onLeave()
end;

function UniaPolonez:onDeactivate()
end;

-- events
SetTramlinesOnEvent = {};
SetTramlinesOnEvent_mt = Class(SetTramlinesOnEvent, Event);

InitEventClass(SetTramlinesOnEvent, "SetTramlinesOnEvent");

function SetTramlinesOnEvent:emptyNew()
    local self = Event:new(SetTramlinesOnEvent_mt);
    self.className="SetTramlinesOnEvent";
    return self;
end;

function SetTramlinesOnEvent:new(vehicle, tramlinesState)
    local self = SetTramlinesOnEvent:emptyNew()
    self.vehicle = vehicle;
	self.tramlinesState = tramlinesState;
    return self;
end;

function SetTramlinesOnEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.tramlinesState = streamReadBool(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function SetTramlinesOnEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.tramlinesState);
end;

function SetTramlinesOnEvent:run(connection)   
	self.vehicle:setTramlinesOn(self.tramlinesState, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(SetTramlinesOnEvent:new(self.vehicle, self.tramlinesState), nil, connection, self.vehicle);
    end;
end;

function SetTramlinesOnEvent.sendEvent(vehicle, tramlinesState, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(SetTramlinesOnEvent:new(vehicle, tramlinesState), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(SetTramlinesOnEvent:new(vehicle, tramlinesState));
		end;
	end;
end;